#include "DualCoding/DualCoding.h"

using namespace DualCoding;

// Radial Search
Point radialSearch(Point &origin, const Point &startPt, const Point &endPt, Sketch<bool> sketch);
ShapeRoot radialSearch(const ShapeRoot &origin, const Point &startPt, const Point &endPt, const UnaryShapeRootPred &pred);

// Contour Tracing Search
std::vector<Point> contourSearch(const Point &startPt, Sketch<uint> &sketch, uint contour, uint target);
std::vector<ShapeRoot> contourSearch(ShapeRoot &startPt, const UnaryShapeRootPred &pred);

double angle (int x1, int x2, int y1, int y2);
void set_pixel(Sketch<uint> &sketch, int i, int j, int val);
